/*
	snd_ctrl.c is a volume control for SB16, that uses libcontrol, and is 
	Inspirited in slider.c from FGB(/n/contrib/fgb/slider.c)

	This program was writed in a Pentium 100 overclocked to 120 with a SB32 AWE!,
       	and 32MB of RAM!
	My E-mail is: x_sp4g3r@yahoo.com.br 
*/

#include <u.h>
#include <libc.h>
#include <thread.h>
#include <draw.h>
#include <mouse.h>
#include <keyboard.h>
#include <control.h>
// number of bars 
#define B		8

Controlset *cs;

int ctldeletequits = 1;

char bname[] = "bar0";
char bshow[] = "bar0 show";
char lname[] = "label0";
char bshow[] = "label0 show";

Image *bg, *winbg;

void
resizecontrolset(Controlset*)
{
	int i, p, s;
	Rectangle r;

	if(getwindow(display, Refnone) < 0)
		sysfatal("resize failed: %r");
	r = screen->r; //r = insetrect(screen->r, 10);

	p = r.max.x - r.min.x;	// width of the window	

	/* s is a window width proportional space to spaces of the window :O */
	s = p / ((3 * B) - 1);

	r.min.x += s;	// let one blank space in the left of the window
	r.max.x = r.min.x 2 * s;	// two spaces to the bar width

	draw(screen, screen->r, winbg, nil, ZP);

	for(i = 0x30; i < 0x30 + B; i++) {
		bshow[3] = i;

		chanprint(cs->ctl, "bar%c rect %R", i, r);
		chanprint(cs->ctl, bshow);
		r.min.x = r.min.x + (3 * s);
		r.max.x = r.min.x + (2 * s);
	}
}

void
threadmain(int argc, char *argv[])
{
	char *s, *args[3];
	Channel *c;
	Control *bars[B], *labels[B];	// may be better in a structure
	int n, i, z;
	Rectangle pos;
	int arq;

	arq = open("/dev/volume", OWRITE);
	if(arq < 0) {
		print("Archive\n");
		exits("archive");
	}

	pos.min.y = 20;	pos.max.y = 200;

	initdraw(0, 0, "Sound Control");

	bg = allocimage(display,Rect(0,0,1,1), CMAP8, 1, 0xEE0000FF);	// red
	namectlimage(bg, "bg");

	winbg = allocimagemix(display, DBlack, DWhite);

	initcontrols();
	cs = newcontrolset(screen, nil, nil, nil);

	for(i = 0x30; i < 0x30 + B; i++) {
		z = i - 0x30;
		bname[3] = i;

		/* bars[z] initialization */	
		bars[z] = createslider(cs, bname);
		chanprint(cs->ctl, "bar%c absolute 1", i);
		chanprint(cs->ctl, "bar%c clamp low 100", i);
		chanprint(cs->ctl, "bar%c border 2", i);
		chanprint(cs->ctl, "bar%c bordercolor palegreen", i);
		//chanprint(cs->ctl, "bar%c size 1 1 20 10", i);
		chanprint(cs->ctl, "bar%c indicatorcolor paleyellow", i);
		chanprint(cs->ctl, "bar%c max 120",i);
		chanprint(cs->ctl, "bar%c orient vertical",i);
		chanprint(cs->ctl, "bar%c value 80", i);
		chanprint(cs->ctl, "bar%c vis 120", i);
		chanprint(cs->ctl, "bar%c image bg", i);

		/* labels[z] initialization */
		/*
		labels[z] = createlabel(cs, lname);
		chanprint(cs->ctl, "label%c ", i);
		*/
	}

	c = chancreate(sizeof(char*), 0);

	for(i = 0; i < B; i++) {
		controlwire(bars[i], "event", c);
		activate(bars[i]);
		/*
		controlwire(labels[i], "event", c);
		activate(labels[i]);
		*/
	}

	resizecontrolset(cs);

	for(;;){
		s = recvp(c);
		n = tokenize(s, args, nelem(args));
		if(n = 3) {
			if(!strcmp(args[0], "bar0:"))
				fprint(arq, "audio out %s", args[2]);
			if(!strcmp(args[0], "bar1:"))
				fprint(arq, "synth %s", args[2]);
			if(!strcmp(args[0], "bar2:"))
				fprint(arq, "cd %s", args[2]);
			if(!strcmp(args[0], "bar3:"))
				fprint(arq, "line %s", args[2]);
			if(!strcmp(args[0], "bar4:"))
				fprint(arq, "mic %s", args[2]);
			if(!strcmp(args[0], "bar5:"))
				fprint(arq, "speaker out %s", args[2]);
			if(!strcmp(args[0], "bar6:"))
				fprint(arq, "treb out %s", args[2]);
			if(!strcmp(args[0], "bar7:"))
				fprint(arq, "bass out %s", args[2]);
		}
	}
	threadexitsall(nil);
}

