/*
	snd_ctrl.c is a volume control for SB16, that uses libcontrol, and is 
	Inspirited in slider.c from FGB

	This program was writed in a Pentium 100 overclocked to 120 with a SB32 AWE!
       	and 32MB of RAM!
	My E-mail is: x_sp4g3r@yahoo.com.br 

*/

#include <u.h>
#include <libc.h>
#include <thread.h>
#include <draw.h>
#include <mouse.h>
#include <keyboard.h>
#include <control.h>
// number of bars 
#define	B	8

Controlset *cs;

int ctldeletequits = 1;

Image *bg, *winbg;

char *ctrls[] = {
	"audio_out",
	"synth",
	"cd",
	"line",
	"mic",
	"speaker",
	"treb_out",
	"bass_out",
	0
};

void
resizecontrolset(Controlset*)
{
	int i, p, s;
	Rectangle r;

	if(getwindow(display, Refnone) < 0)
		sysfatal("resize failed: %r");
	r = screen->r; //r = insetrect(screen->r, 10);

	p = r.max.x - r.min.x;	// width of the window	

	/*
		s is a proportional value to the width of the bars
	*/
	s = p / ((3 * B +1) - 1);

	r.min.x += s;	// let one space of the left of the window
	r.max.x = r.min.x + 2 * s;

	draw(screen, screen->r, winbg, nil, ZP);

	for(i = 0; i < B; i++) {
		chanprint(cs->ctl, "%q rect %R", ctrls[i], r);
		r.min.x = r.min.x + (3 * s);
		r.max.x = r.min.x + (2 * s);
	}
	chanprint(cs->ctl, "'entry slider' show");
}

void
threadmain(int argc, char *argv[])
{
	char *s, *args[3];
	Channel *c;
	Control *bars[B], *labels[B];	// may be better in a structure
	int n, i, z;
	Rectangle pos;
	int arq;

	arq = open("/dev/volume", OWRITE);
	if(arq < 0) {
		print("Archive\n");
		exits("archive");
	}

	pos.min.y = 20;	pos.max.y = 200;

	initdraw(0, 0, "Sound Control");

	bg = allocimage(display,Rect(0,0,1,1), CMAP8, 1, 0xEE0000FF);	// red
	namectlimage(bg, "bg");

	winbg = allocimagemix(display, DBlack, DWhite);

	initcontrols();
	cs = newcontrolset(screen, nil, nil, nil);

	for(i = 0; i < B; i++) {
		/* bars[i] initialization */	
		bars[i] = createslider(cs, ctrls[i]);
		chanprint(cs->ctl, "audio_out format %q", "%q: bla %d"); 
		
		/* labels[i] initialization */
		/*
		labels[z] = createlabel(cs, lname);
		chanprint(cs->ctl, "label%c ", );
		*/
	}
	
	chanprint(cs->ctl, "'entry slider' absolute 1");
	chanprint(cs->ctl, "'entry slider' clamp low 100");
	chanprint(cs->ctl, "'entry slider' border 2");
	chanprint(cs->ctl, "'entry slider' bordercolor palegreen");
	chanprint(cs->ctl, "'entry slider' indicatorcolor paleyellow");
	chanprint(cs->ctl, "'entry slider' max 120");
	chanprint(cs->ctl, "'entry slider' orient vertical");
	chanprint(cs->ctl, "'entry slider' value 80");
	chanprint(cs->ctl, "'entry slider' vis 120");
	chanprint(cs->ctl, "'entry slider' image bg");

	c = chancreate(sizeof(char*), 0);

	for(i = 0; i < B; i++) {
		controlwire(bars[i], "event", c);
		activate(bars[i]);
		//controlwire(labels[i], "event", c);
		//activate(labels[i]);
	}

	resizecontrolset(cs);

	for(;;){
		s = recvp(c);
		n = tokenize(s, args, nelem(args));
		if(n = 2) 
			//fprint(arq, "%s %s", args[0], args[2]);
			print("%s", s);
		//}
	}
	threadexitsall(nil);
}

